Botan: Botan::Turing Class Reference

Botan 1.10.16

Public Member Functions | List of all members
Botan::Turing Class Reference

`#include <turing.h>`

Inheritance diagram for Botan::Turing:

## Public Member Functions
void | cipher (const byte in[], byte out[], size_t length)
void | cipher1 (byte buf[], size_t len)
void | clear ()
StreamCipher * | clone () const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
void | set_iv (const byte iv[], size_t iv_length)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
| Turing ()
bool | valid_iv_length (size_t iv_len) const
bool | valid_keylength (size_t length) const

## Detailed Description

Turing

Definition at line 18 of file turing.h.

## Constructor & Destructor Documentation

## ◆ Turing()

Botan::Turing::Turing | ( |  | ) |
| inline

Definition at line 36 of file turing.h.

36 : S0(256), S1(256), S2(256), S3(256),
37 R(17), buffer(340), position(0) {}

## Member Function Documentation

## ◆ cipher()

void Botan::Turing::cipher | ( | const byte | in[],
|  | byte | out[],
|  | size_t | len
| ) |  |
| virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 38 of file turing.cpp.

References Botan::get_byte(), R0, R1, R10, R11, R12, R2, R3, R4, R5, R6, R7, R8, R9, Botan::MemoryRegion< T >::resize(), Botan::rotate_left(), set_iv(), Botan::MemoryRegion< T >::size(), Botan::store_be(), and Botan::xor_buf().

39 {
40 while(length >= buffer.size() - position)
41 {
42 xor_buf(out, in, &buffer[position], buffer.size() - position);
43 length -= (buffer.size() - position);
44 in += (buffer.size() - position);
45 out += (buffer.size() - position);
46 generate();
47 }
48 xor_buf(out, in, &buffer[position], length);
49 position += length;
50 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21

## ◆ cipher1()

void Botan::StreamCipher::cipher1 | ( | byte | buf[],
|  | size_t | len
| ) |  |
| inlineinherited

Encrypt or decrypt a message

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 34 of file stream_cipher.h.

Referenced by Botan::Lion::decrypt_n(), and Botan::Lion::encrypt_n().

35 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const byte in[], byte out[], size_t len)=0

## ◆ clear()

void Botan::Turing::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 314 of file turing.cpp.

References Botan::zeroise().

315 {
316 zeroise(S0);
317 zeroise(S1);
318 zeroise(S2);
319 zeroise(S3);
320
321 zeroise(buffer);
322 position = 0;
323 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

StreamCipher* Botan::Turing::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 34 of file turing.h.

34 { return new Turing; }
Botan::Turing::Turing
Turing()
Definition: turing.h:36

## ◆ key_spec()

Key_Length_Specification Botan::Turing::key_spec | ( |  | ) | const
| inlinevirtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 27 of file turing.h.

28 {
29 return Key_Length_Specification(4, 32, 4);
30 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::Turing::name | ( |  | ) | const
| inlinevirtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 33 of file turing.h.

Referenced by set_iv().

33 { return "Turing"; }

## ◆ set_iv()

void Botan::Turing::set_iv | ( | const byte | iv[],
|  | size_t | iv_len
| ) |  |
| virtual

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Reimplemented from Botan::StreamCipher.

Definition at line 282 of file turing.cpp.

References Botan::get_byte(), name(), Botan::MemoryRegion< T >::size(), and valid_iv_length().

Referenced by cipher().

283 {
284 if(!valid_iv_length(length))
285 throw Invalid_IV_Length(name(), length);
286
287 SecureVector<u32bit> IV(length / 4);
288 for(size_t i = 0; i != length; ++i)
289 IV[i/4] = (IV[i/4] << 8) + iv[i];
290
291 for(size_t i = 0; i != IV.size(); ++i)
292 R[i] = IV[i] = fixedS(IV[i]);
293
294 for(size_t i = 0; i != K.size(); ++i)
295 R[i+IV.size()] = K[i];
296
297 R[K.size() + IV.size()] = (0x010203 << 8) | (K.size() << 4) | IV.size();
298
299 for(size_t i = K.size() + IV.size() + 1; i != 17; ++i)
300 {
301 const u32bit W = R[i-K.size()-IV.size()-1] + R[i-1];
302 R[i] = S0[get_byte(0, W)] ^ S1[get_byte(1, W)] ^
303 S2[get_byte(2, W)] ^ S3[get_byte(3, W)];
304 }
305
306 PHT(R);
307
308 generate();
309 }
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::Turing::name
std::string name() const
Definition: turing.h:33
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::Turing::valid_iv_length
bool valid_iv_length(size_t iv_len) const
Definition: turing.h:24
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::set_key(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_iv_length()

bool Botan::Turing::valid_iv_length | ( | size_t | iv_len | ) | const
| inlinevirtual

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented from Botan::StreamCipher.

Definition at line 24 of file turing.h.

Referenced by set_iv().

25 { return (iv_len % 4 == 0 && iv_len <= 16); }

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/stream/turing/turing.h
- src/stream/turing/tur_tab.cpp
- src/stream/turing/turing.cpp